//	2000/10/02 Ogasawara Hiroyuki

#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<unistd.h>
#include	<math.h>
#include	<time.h>

static void
decode_mount( char *ptr )
{
	char	*arg[8];
	char	**argp= arg;
	for(; *ptr ;){
		for(; *ptr == ' ' || *ptr == '\t' ; ptr++ );
		*argp++= ptr;
		for(; *ptr && *ptr != ' ' && *ptr != '\t' ; ptr++ );
		if( *ptr ){
			*ptr++= '\0';
		}
	}
	mount( arg[0], arg[1], arg[2], 0xc0ed0000|0, arg[3] );
}

static void
_fstab()
{
	FILE	*fp= fopen( "/etc/fstab", "r" );
	if( fp ){
		char	buf[256];
		for(; fgets( buf, 255, fp ) ;){
			decode_mount( buf );
		}
		fclose( fp );
	}
}

int
main( int argc, char **argv )
{
	char	*device= NULL;
	char	*mountpoint= NULL;
	char	*option= NULL;
	char	*fstype= "ext2";
	for(; --argc ;){
		if( **++argv == '-' ){
			switch( (*argv)[1] ){
			case 'a':
				_fstab();
				return	0;
			case 'o':
				if( (*argv)[2] ){
					option= *argv+2;
				}else if( argc > 1 ){
					argc--;
					option= *++argv;
				}
				break;
			case 't':
				if( (*argv)[2] ){
					fstype= *argv+2;
				}else if( argc > 1 ){
					argc--;
					fstype= *++argv;
				}
				break;
			}
		}else{
			if( !device ){
				device= *argv;
			}else{
				mountpoint= *argv;
			}
		}
	}
	if( device && mountpoint ){
		int	err;
//	printf( "[%s][%s][%s][%s]\n", device, mountpoint, fstype, option ? option : "-" );
	//err= mount( device, mountpoint, fstype, 0xc0ed0000|32, option );
	err= mount( device, mountpoint, fstype, 0xc0ed0000|0, option );
		if( err < 0 ){
			puts( "mount error" );
		}
	}else{
		puts(
			"usage: mount [opt] device mountpoint [opt]\n"
			" -t\tmount type (/proc/filesystems)\n"
			" -o\toption\n"
			" -a\tuse fstab\n"
		);
	}
	return	0;
}

