//	2000/10/09 Ogasawara Hiroyuki

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>

#include	"zaugraph.h"

static int
devicetest()
{
	_ZauGraphParam	GParam;
	int	fn= open( "/dev/zgraph", O_WRONLY );
	if( fn < 0 ){
		char	*msg= "device open error\n";
		write( 1, msg, strlen(msg) );
		return	0;
	}
	ioctl( fn, 0, &GParam );
	if( GParam.Width != 640 ){
		char	*msg= "device is not VGA\n";
		write( 1, msg, strlen(msg) );
		close( fn );
		return	0;
	}
	close( fn );
	return	1;
}

static void
bgcopy( char *data )
{
	int	fn= open( "/dev/zgraph", O_WRONLY );
	if( fn < 0 ){
		char	*msg= "device open error\n";
		write( 1, msg, strlen(msg) );
		return;
	}
#if 0
	{
		int	i;
		for( i= 0 ; i< 304 ; i++ ){
			write( fn, data, sizeof(short) * 640 );
			data+= sizeof(short)*640;
		}
	}
#else
	write( fn, data, sizeof(short) * 640*304 );
#endif
	close( fn );
}


static char *
bgload( char *file )
{
	char	*datap= (char*)malloc( sizeof(short) * 640 * 304 );
	int	fn;
	if( !datap ){
		return	NULL;
	}
	fn= open( file, O_RDONLY );
	if( fn >= 0 ){
		_ZitFileHead	zit;
		read( fn, &zit, sizeof(_ZitFileHead) );
		if( zit.Head != 'Z'+'T'*256 ){
			char	*msg= "is not zit\n";
			write( 1, msg, strlen(msg) );
			close( fn );
			return	NULL;
		}
		if( zit.X != 640 || zit.Y < 304 ){
			char	*msg= "zit too small\n";
			write( 1, msg, strlen(msg) );
			close( fn );
			return	NULL;
		}
		read( fn, datap, sizeof(short) * 640 * 304 );
		close( fn );
		return	datap;
	}else{
		char	*msg= "open error\n";
		write( 1, msg, strlen(msg) );
	}
	return	NULL;
}

int
main( int argc, char **argv )
{
	if( argc >= 2 ){
		char	*datap;
		if( !devicetest() ){
			return	1;
		}
		datap= bgload( argv[1] );
		if( datap ){
			bgcopy( datap );
			write( 1, "\033[2J", 4 );	// CLS
		}
	}else{
		char	*msg=
			"usage: bgload <zitfile>\n"
			"  VGA Only\n";
		write( 1, msg, strlen(msg) );
	}
	return	0;
}

