//	2000/10/09 Ogasawara Hiroyuki

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>

#include	"zaugraph.h"

static _ZauGraphParam	GParam;
static _ZitFileHead	Zit;
static unsigned char	*Datap;

static void
msg( char *ptr )
{
	write( 1, ptr, strlen(ptr) );
}

static int
SpecLoad()
{
	int	fn= open( "/dev/zgraph", O_WRONLY );
	if( fn < 0 ){
		msg( "device open error\n" );
		return	0;
	}
	ioctl( fn, 0, &GParam );
	close( fn );
	return	1;
}

static int
put()
{
	int	fn= open( "/dev/zgraph", O_WRONLY );
	int	i;
	unsigned char	*data= Datap;
	if( fn < 0 ){
		msg( "device open error\n" );
		return	0;
	}
	for( i= 0 ; i< Zit.Y && i < GParam.Height ; i++ ){
		write( fn, data, sizeof(short) * Zit.X );
		lseek( fn, sizeof(short)*(GParam.Width - Zit.X), 1 );
		data+= sizeof(short)*Zit.X;
	}
	close( fn );
	return	1;
}


static int
zitload( char *file )
{
	int	fn;
	if( !(Datap= (char*)malloc( sizeof(short) * 640 * 480 )) ){
		return	0;
	}
	fn= open( file, O_RDONLY );
	if( fn >= 0 ){
		read( fn, &Zit, sizeof(_ZitFileHead) );
		if( Zit.Head != 'Z'+'T'*256 ){
			msg( "is not zit\n" );
			close( fn );
			return	0;
		}
		if( Zit.X > GParam.Width || Zit.Y > GParam.Height ){
			msg( "zit too big\n" );
			close( fn );
			return	0;
		}
		read( fn, Datap, sizeof(short) * Zit.X * Zit.Y );
		close( fn );
		return	1;
	}else{
		msg( "open error\n" );
	}
	return	0;
}

int
main( int argc, char **argv )
{
	if( argc >= 2 ){
		char	ch;
		if( !SpecLoad() ){
			return	1;
		}
		if( !zitload( argv[1] ) ){
			return	1;
		}
		if( !put() ){
			return	1;
		}
		read( 0, &ch, 1 );
		msg( "\033[2J" );	// CLS
	}else{
		msg( "usage: zitload <zitfile>\n" );
	}
	return	0;
}

