//	2000/10/10 Ogasawara Hiroyuki

#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>

#include	"zaugraph.h"

static _ZauGraphParam	GParam;
static _ZitFileHead	Zit;
static unsigned char	*Datap;

static void
msg( char *ptr )
{
	write( 1, ptr, strlen(ptr) );
}

static int
SpecLoad()
{
	int	fn= open( "/dev/zgraph", O_WRONLY );
	if( fn < 0 ){
		msg( "device open error\n" );
		return	0;
	}
	ioctl( fn, 0, &GParam );
	close( fn );
	return	1;
}

static int
put()
{
	int	fn= open( "/dev/zgraph", O_WRONLY );
	int	i;
	unsigned char	*data= Datap;
	if( fn < 0 ){
		msg( "device open error\n" );
		return	0;
	}
	if( GParam.Width == 640 ){
		lseek( fn, sizeof(short)*( 640*(8+14)+(640-256)/2 ), 1 );
	}else{
		lseek( fn, sizeof(short)*( 320*(12)+(320-128)/2 ), 1 );
	}
	for( i= 0 ; i< Zit.Y && i < GParam.Height ; i++ ){
		write( fn, data, sizeof(short) * Zit.X );
		lseek( fn, sizeof(short)*(GParam.Width - Zit.X), 1 );
		data+= sizeof(short)*Zit.X;
	}
	close( fn );
	return	1;
}


static int
zitload( char *file )
{
	int	fn;
	if( !(Datap= (char*)malloc( sizeof(short) * 256 * 256 )) ){
		return	0;
	}
	fn= open( file, O_RDONLY );
	if( fn >= 0 ){
		read( fn, &Zit, sizeof(_ZitFileHead) );
		read( fn, Datap, sizeof(short) * Zit.X * Zit.Y );
		close( fn );
		return	1;
	}else{
		msg( "open error\n" );
	}
	return	0;
}

int
main( int argc, char **argv )
{
	char	ch;
	time_t	t;
	if( !SpecLoad() ){
		return	1;
	}
	srand( time( &t ) );
	if( !zitload( GParam.Width == 640 ?
			"/etc/pen256.zit" :
			(
				(rand() & 32) ?
					"/etc/pen128.zit" :
					"/etc/pen128b.zit"
			)
				) ){
		return	1;
	}
	if( !put() ){
		return	1;
	}
	read( 0, &ch, 1 );
	return	0;
}

